<template>
  <div class="edit-keyword">
    <div class="edit-keyword__main">
      <prime-button
        :icon="`pi ${isOpen ? 'pi-angle-down' : 'pi-angle-right'}`"
        class="p-button-rounded p-button-primary p-button-sm p-button-text"
        @click="isOpen = !isOpen"
      />
      <span class="keyword__value">{{ keyword.value }}</span>
      <prime-button
        icon="pi pi-times"
        class="p-button-rounded p-button-danger p-button-text p-button-sm"
        @click="deleteConfirmation"
      />
    </div>
    <div v-if="isOpen" class="edit-keyword__open">
      <form @submit.prevent="submit">
        <prime-dropdown
          v-model="keywordGroup"
          :options="filteredKeywordGroups"
          option-label="name"
          :filter="true"
        >
          <template #option="{option}">
            <keyword-group-chip :keyword-group="option" />
          </template>
          <template #value="{ value }">
            <div
              v-if="value !== null"
              class="edit-keyword__value-wrapper"
            >
              <div class="edit-keyword__value edit-keyword__value_hidden">
                {{ value.name }}
              </div>
              <span
                class="edit-keyword__value edit-keyword__value_absolute"
                :style="{ 'background-color': value.color, color: getKeywordGroupColor(value) }"
              >
                {{ value.name }}
              </span>
            </div>
            <div v-else class="edit-keyword__value_hidden">
              dqw
            </div>
          </template>
        </prime-dropdown>
        <prime-button
          class="edit-keyword__open-button"
          type="submit"
          label="Добавить"
        />
      </form>
      <div v-if="keyword.relations.length > 0" class="edit-keyword__open-wrapper">
        <div
          v-for="keywordRelation in keyword.relations"
          :key="keywordRelation.id"
          class="edit-keyword__open-item"
        >
          <keyword-group-chip :keyword-group="keywordRelation.group" />
          <prime-button
            icon="pi pi-times"
            class="p-button-rounded p-button-danger p-button-text p-button-sm"
            @click="deleteKeywordRelation(keywordRelation)"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import PrimeButton from 'primevue/button/Button.vue';
import PrimeDropdown from 'primevue/dropdown/Dropdown.vue';
import { defineComponent, PropType } from 'vue';
import { createKeywordRelation, deleteKeywordRelation } from '@/api/handler/keywords';
import { getKeywordGroupColor } from '@/api/keywordGroups';
import KeywordGroupChip from '@/components/KeywordGroupChip.vue';
import { KeywordGroup } from '@/models/keywordGroup';
import { KeywordRelation, KeywordWithRelations } from '@/models/keywords';

interface Data {
  keywordGroup: KeywordGroup | null;
  isOpen: boolean;
}

export default defineComponent({
  name: 'edit-keyword',
  components: {
    PrimeButton,
    PrimeDropdown,
    KeywordGroupChip,
  },
  props: {
    keyword: { type: Object as PropType<KeywordWithRelations>, required: true },
    keywordGroups: { type: Array as PropType<KeywordGroup[]>, required: true },
  },
  emits: ['delete-relation', 'create-relation', 'delete'],
  data(): Data {
    return {
      keywordGroup: null,
      isOpen: false,
    };
  },
  computed: {
    filteredKeywordGroups(): KeywordGroup[] {
      return this.keywordGroups.filter(group => {
        return this.keyword.relations.find(relation => relation.group.id === group.id) === undefined;
      });
    },
  },
  methods: {
    async submit() {
      if (this.keywordGroup === null) {
        return;
      }
      const res = await createKeywordRelation({ group: this.keywordGroup.id, keyword: this.keyword.id });
      if (res.__state === 'success') {
        this.$emit('create-relation', res.data);
        this.keywordGroup = null;
      }
    },
    deleteConfirmation() {
      this.$confirm.require({
        message: `Вы уверены, что хотите удалить ключевое слово "${this.keyword.value}"? Все данные, связанные с этим ключевым словом, будут потеряны!`,
        header: `Удаление ключевого слово "${this.keyword.value}"`,
        icon: 'pi pi-exclamation-triangle',
        accept: () => {
          this.$emit('delete');
        },
      });
    },
    async deleteKeywordRelation(keywordRelation: KeywordRelation) {
      const res = await deleteKeywordRelation({ id: keywordRelation.id });

      if (res.__state === 'success') {
        this.$emit('delete-relation', { keywordRelation, keyword: this.keyword });
      }
    },
    getKeywordGroupColor,
  },
});
</script>
<style lang="scss" scoped>
.edit-keyword {

  &__value-wrapper {
    position: relative;
  }

  &__value {

    &_hidden {
      position: block;
      transform: unset;
      visibility: hidden;
    }

    &_absolute {
      position: absolute;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      padding: 5px;
      border-radius: 3px;
    }
  }

  &__main {
    display: flex;
    align-items: center;
    margin-bottom: 10px;

    & > *:not(:last-child) {
      margin-right: 10px;
    }
  }

  &__open {
    margin-left: calc(2.357rem + 10px);
    margin-bottom: 10px;
  }

  &__open-button {
    margin-left: 10px;
  }

  &__open-wrapper {
    display: flex;
    flex-wrap: wrap;
    margin-bottom: 10px;
  }

  &__open-item {
    display: flex;
    align-items: center;
    margin-top: 8px;
  }
}
</style>
